function s_blk = bl_shift(blk,shift_matrix,N1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% This function shift block to top left based on shift_matrix 
%
%
% INPUT ARGUMENT: 
% blk: unshifted block
% shift_matrix: (cell) each entry coresponds to where it should shifted (x_shift,
% y_shift)
% N1: block size
%
% OUTPUT ARGUMENT:
% blk: shifted block
%
%
s_blk = zeros(N1);

for i=1:N1
    for j=1:N1
        if isempty(shift_matrix{i,j})~=1
            s_blk(shift_matrix{i,j}(1),shift_matrix{i,j}(2)) = blk(i,j);
        end
    end
end

