function wxr = bl_weight(Wsx,sigma,shp_wsx)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% This function calculates weighting factor for a block stack

%
%
% INPUT ARGUMENT:
% Wsx (3D matrix): shrinkage wiener coefficient
% 
%
% OUTPUT ARGUMENT
% wxr: weighting factor
Wsx = Wsx.^2;
if exist('shp_wsx')==1
   Wsx = Wsx.*shp_wsx; 
end
wxr = 1/(sigma^2*sum(sum(sum(Wsx,3))));

